﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;
//using Microsoft.Practices.Prism.ViewModel;
//using UFP.LumberTrack.Production.Management.Costing.Windows;
//using UFP.LumberTrack.Production.Presentation.BlackBox;
//using UFP.LumberTrack.Production.Presentation.BlackBox.PropertyCoalescer;
//using UFP.LumberTrack.Production.Presentation.Maintenance;
using XamGridFieldLayout;


namespace UFP.LumberTrack.Production.Management.Batch.Status.Windows
{


    
    /// <summary>
    /// Show a better label.
    /// </summary>
    public class StatusTypeLabelConverter :  IValueConverter
    {
        
        /// <summary>
        /// Convert this value to a visibility (collapsed or visible)
        /// </summary>
        public object Convert(
            object p_Value, 
            Type p_TargetType, 
            object p_Parameter, 
            System.Globalization.CultureInfo p_Culture)
        {
            // Get the string
            string ValueStatusType = p_Value as string;

            // Format the string
            string FormatString = p_Parameter.ToString();

            // Not available
            if(ValueStatusType == null) return null;

            // Get the result
            string Result = "Batch or Run";
            if(ValueStatusType == "CSM")
            { Result = "Consumed"; }
            if(ValueStatusType == "PRD")
            { Result = "Produced"; }

            // Return after formatting
            return string.Format(FormatString, Result);
        }



        /// <summary>
        /// Convert back again.
        /// </summary>
        public object ConvertBack(object p_Value, Type p_TargetType, object p_Parameter, System.Globalization.CultureInfo p_Culture)
        {
            throw new NotImplementedException();
        }
 
    }



    /// <summary>
    /// Interaction logic for StatusBatchWindow.xaml
    /// </summary>
    public partial class StatusBatchWindow : Window
    {
        /// <summary>
        /// Next time we have gain/loss notes to enter, put them here.
        /// </summary>
        private Point m_ScreenPositionForGainLossNotes;

        /// <summary>
        /// Better type for most purposes.
        /// </summary>
        private BatchStatusViewModel ViewModelContext
        { get { return ((BatchStatusViewModel)this.DataContext); } }
        


        /// <summary>
        /// Keeps track of viewmodel to watch for a change
        /// that would impact data in the underlying app server model.
        /// </summary>
        //private AppServerModelCoalescer m_AppServerModelChangeWatcher;

        

        /// <summary>
        /// Parent form for centering.
        /// </summary>
        private System.Windows.Forms.Form m_FormParent;

        
        /// <summary>
        /// Relay to clients if the status was actually changed.
        /// </summary>
        //public bool AppServerModelChanged { get { return m_AppServerModelChangeWatcher.AppServerModelChanged; } }


        /// <summary>
        /// Assign the data context.  When null, use the pre-existing DataContext (for resetting purposes)
        /// </summary>
        public void AssignNewDataContext(
            BatchStatusViewModel p_ViewModel)
        {
            // Parameters and existing
            BatchStatusViewModel ViewModelObj = p_ViewModel;
            BatchStatusViewModel ExistingViewModelForBinding  = this.DataContext as BatchStatusViewModel;

            // Use existing when
            // a new one isn't presented
            if(ViewModelObj == null)
            { ViewModelObj = ExistingViewModelForBinding; }

            // Resetting the context
            if(this.DataContext != null)
            { this.DataContext = null; }

            // Setting the context
            this.DataContext = ViewModelObj;
        }
         
        
        /// <summary>
        /// Construct
        /// </summary>
        public StatusBatchWindow(
            Window p_WindowParent,
            int p_BatchNumber, 
            string p_StatusTypeForCompletion) : this(
            (System.Windows.Forms.Form)null, 
            p_BatchNumber, 
            p_StatusTypeForCompletion)
        {
            // The owner (for centering, etc)
            this.Owner = p_WindowParent;
        }


        /// <summary>
        /// Construct
        /// </summary>
        public StatusBatchWindow(
            System.Windows.Forms.Form p_FormParent, 
            int p_BatchNumber, 
            string p_StatusTypeForCompletion)
        {
            // Designer
            InitializeComponent();
            
            // Parent
            //m_FormParent = p_FormParent;
            
            //// Windows form parent
            //if(m_FormParent != null)
            //{
            //    // Use interop helper 
            //    WindowInteropHelper WindowHelper = new WindowInteropHelper(this);
            //    WindowHelper.Owner = m_FormParent.Handle;
                 
            //}


            // Create VM and assign to datacontext
            BatchStatusViewModel ViewModelObj = new BatchStatusViewModel((IApplicationSessionProperties)null, p_BatchNumber, p_StatusTypeForCompletion);
            //ViewModelObj.ProviderOfToleranceNotes = this;
            //ViewModelObj.Dispatcher = this;

            //// Property changse
            //ViewModelObj.PropertyChanged += ViewModel_PropertyChanged;

            //// Satisfy remaining dependencies and assign data context
            //MefCatalog.SatisfyImportsFromAttributedServices(ViewModelObj);
            AssignNewDataContext(ViewModelObj);

            // Watch for changes in status in the underlying app server model
            //m_AppServerModelChangeWatcher = new AppServerModelCoalescer(new INotifyPropertyChanged[] { ViewModelObj } );

            // Reset with updates from  model 
            ViewModelContext.ResetViewModelData();
        }

        /// <summary>
        /// Something is changing in our viewmodel.
        /// Use p_Args to see if we are interested.
        /// </summary>
        void ViewModel_PropertyChanged(object p_Sender, System.ComponentModel.PropertyChangedEventArgs p_Args)
        {
            //// Keep track of property with mouse cursor
            //if(p_Args.PropertyName == "IsBusyWithSelfInitiatedOperation")
            //{
            //    // Immediately set the cursor
            //    Mouse.OverrideCursor = null; 

            //    // Detect busy
            //    if(ViewModelContext.IsBusyWithSelfInitiatedOperation)
            //    { 
            //        // Immediately set the cursor
            //        Mouse.OverrideCursor = Cursors.Wait; 

            //        // Send the action off on the message pump.  This will revert the mouse cursor when idle.
            //        Dispatcher.BeginInvoke(new Action(() => Mouse.OverrideCursor = null), System.Windows.Threading.DispatcherPriority.ContextIdle, null); 
            //    }
            //}
        }

        

        /// <summary>
        /// The window loaded
        /// </summary>
        private void ThisWindow_Loaded(object sender, RoutedEventArgs e)
        {
            //// Save the position for gain/loss
            //m_ScreenPositionForGainLossNotes = ScreenPositionOfGrid;

            //// Windows form parent
            //if(m_FormParent != null)
            //{
            //    // Center
            //    this.Left = m_FormParent.Left + (m_FormParent.Width - this.ActualWidth) / 2;
            //    this.Top = m_FormParent.Top + (m_FormParent.Height - this.ActualHeight) / 2;
            //}

        }

        /// <summary>
        /// Position on the screen
        /// </summary>
        public Point ScreenPositionOfGrid
        {
            get 
            {
                // Relative to the entire screen
                return  m_StatusBatchEdit.PointToScreen(new Point(0,0));
            }
        }
        
        /// <summary>
        /// Implements IProvideToleranceOverrideNotes.
        /// </summary>
        public Point PreferredScreenPosition
        {
            get { return m_ScreenPositionForGainLossNotes; } 
            set { m_ScreenPositionForGainLossNotes = value; }
        }



        /// <summary>
        /// Implements IProvideToleranceOverrideNotes.
        /// Get the tolerance notes to be used on this run.
        /// </summary>
        //public IEnumerable<string> GetToleranceOverrideNotes(
        //    string p_BranchCode, 
        //    int p_RunNumber,
        //    string p_WarningMessage,
        //    string p_GainLossForDisplay)
        //{
        //    // Change the cursor
        //    Mouse.OverrideCursor = Cursors.Wait;

        //    try
        //    {
        //        //... using this window to get a new notes
        //        ToleranceNotesWindow WindowObj = new ToleranceNotesWindow(
        //            p_RunNumber,
        //            p_WarningMessage,
        //            p_GainLossForDisplay,
        //            m_ScreenPositionForGainLossNotes);

        //        // Set the cursor back
        //        Mouse.OverrideCursor = null;

        //        // Show the dialog
        //        bool? DialogResult = WindowObj.ShowDialog();
        //        if(!DialogResult.HasValue || DialogResult.Value == false) 
        //        { throw new Exception("User cancelled the initialization of tolerance notes."); }

        //        // Return the data
        //        return WindowObj.GetOverrideNotes();
        //    }
        //    catch (Exception Ex)
        //    {
        //        // Nothing for
        //        // our clients
        //        return null;
        //    }
        //    finally
        //    {
        //        // Set the cursor back
        //        Mouse.OverrideCursor = null;
        //    }
 
        //}

        /// <summary>
        /// Not used
        /// </summary>
        private void ThisWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        { }

        /// <summary>
        /// Closes the window.
        /// </summary>
        private void m_BtnClose_Click(object sender, RoutedEventArgs e)
        { this.Close();  }
        
        /// <summary>
        /// Hide the overflow dropdown.
        /// </summary>
        private void ToolBar_Loaded(object p_Sender, RoutedEventArgs p_Args)
        { }


        

        /// <summary>
        /// Implementation of IDispatcherForContextIdle 
        /// (in UFP.LumberTrack.ViewModeling.Production.ViewModel.Interaction)
        /// Typically used for refreshing.
        ///// </summary>
        //public DispatcherOperation BeginInvoke(Action p_Action)
        //{
        //    // Send the action off on the message pump.
        //    return Dispatcher.BeginInvoke(p_Action, System.Windows.Threading.DispatcherPriority.ContextIdle, null); 
        //}




         
    }
}
